/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package pl.tewi.jeeunit.ejbmodule;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.io.IOException;
import org.glassfish.embeddable.CommandRunner;
import com.sun.enterprise.security.auth.realm.file.FileRealm;
import org.glassfish.embeddable.CommandResult;
import org.glassfish.embeddable.GlassFishException;
import org.glassfish.embeddable.GlassFishProperties;
import org.glassfish.embeddable.BootstrapProperties;
import java.io.File;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.glassfish.embeddable.GlassFish;
import org.glassfish.embeddable.GlassFishRuntime;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

/**
 *
 * @author Marcin Kwapisz
 */
public class SecuredSessionBeanTest {

    public SecuredSessionBeanTest() {
    }
    private static GlassFish gf = null;
    private static GlassFishRuntime gfr = null;

    @BeforeClass
    public static void setUpClass() throws Exception {
      System.out.println("\nBootstrapping\n");
        BootstrapProperties bootstrapProperties = new BootstrapProperties();
//        bootstrapProperties.setInstallRoot("c:\\JavaDev\\Java\\appservers\\glassfish-3.1.1\\glassfish");

        GlassFishProperties glassfishProperties = new GlassFishProperties();
        glassfishProperties.setInstanceRoot(System.getenv("S1AS_HOME") + "/domains/domain1");
        glassfishProperties.setConfigFileReadOnly(true);

//        EJBContainer container = javax.ejb.embeddable.EJBContainer.createEJBContainer();
        gfr = GlassFishRuntime.bootstrap(bootstrapProperties);
        gf = gfr.newGlassFish(glassfishProperties);
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
        System.out.println("\nShutting down\n");
        gf.dispose();
        gf = null;
        gfr.shutdown();
        gfr = null;
    }

    private final static String instanceRoot = System.getenv("S1AS_HOME") + "/domains/domain1";

    @Before
    public void setUp() throws GlassFishException {
        System.out.println("\nStarting GF\n");
        gf.start();
    }

    @After
    public void tearDown() throws GlassFishException {
        System.out.println("\nStopping GF\n");
        gf.stop();
    }

    

    /**
     * Test of testSecuredMethod method, of class SecuredSessionBean.
     */
//    @Test
//    public void testTestSecuredMethod_onceAgain() throws Exception {
//        System.out.println("testSecuredMethod");
//
//        Deployer deployer = gf.getDeployer();
//
//        ScatteredArchive sc = new ScatteredArchive("classes", ScatteredArchive.Type.JAR);
//        sc.addClassPath(new File("target/classes"));
//        sc.addMetadata(new File("src/main/resources/META-INF/glassfish-ejb-jar.xml"));
//
//        deployer.deploy(sc.toURI());
//
//        InitialContext ic = new InitialContext();
//
//        SecuredSessionBeanRemote instance = (SecuredSessionBeanRemote) ic.lookup("java:global/classes/SecuredSessionBean");
//        String expResult = "secured testMetod";
//
//        ProgrammaticLogin pm = new ProgrammaticLogin();
//        pm.login("superuser", "superuser".toCharArray(), "file", true);
//
//        String result = instance.testSecuredMethod();
//        assertEquals(expResult, result);
//
//        deployer.undeploy("classes");
//    }

    @Test
    public void createRealm() throws GlassFishException, Exception {
        String command;
        CommandResult result;

        final String realmName = "realmFirst";

        command = "delete-auth-realm";
        File realmFile = new File(new File(instanceRoot, "config"), realmName);
        if (realmFile.exists()) {
            realmFile.delete();
        }
        CommandRunner runner = (CommandRunner) gf.getCommandRunner();
        result = runner.run(command, realmName);
        if (result.getExitStatus() == CommandResult.ExitStatus.FAILURE && !result.getOutput().contains("not found")) {
            throw new Exception(result.getFailureCause());
        }

        //asadmin> create-auth-realm --classname com.sun.enterprise.security.auth.realm.file.FileRealm --property file=${com.sun.aas.instanceRoot}/config/filerealm:jaas-context=fileRealm fileRealm
        command = "create-auth-realm";
        result = runner.run(command, "--classname", FileRealm.class.getCanonicalName(), "--property", "file=${com.sun.aas.instanceRoot}/config/" + realmName + ":jaas-context=fileRealm", realmName);

        if (result.getExitStatus().equals(CommandResult.ExitStatus.FAILURE)) {
            throw new Exception(result.getFailureCause());
        }

        prepareRealmUsers(realmName);
    }

    @Test
    public void createRealm_onceAgain() throws GlassFishException, Exception {
        String command;
        CommandResult result;

        final String realmName = "realmOnceAgain";

        command = "delete-auth-realm";
        File realmFile = new File(new File(instanceRoot, "config"), realmName);
        if (realmFile.exists()) {
            realmFile.delete();
        }
        CommandRunner runner = (CommandRunner) gf.getCommandRunner();
        result = runner.run(command, realmName);
        if (result.getExitStatus() == CommandResult.ExitStatus.FAILURE && !result.getOutput().contains("not found")) {
            throw new Exception(result.getFailureCause());
        }
        
        //asadmin> create-auth-realm --classname com.sun.enterprise.security.auth.realm.file.FileRealm --property file=${com.sun.aas.instanceRoot}/config/filerealm:jaas-context=fileRealm fileRealm
        command = "create-auth-realm";
        result = runner.run(command, "--classname", FileRealm.class.getCanonicalName(), "--property", "file=${com.sun.aas.instanceRoot}/config/" + realmName + ":jaas-context=fileRealm", realmName);


        if (result.getExitStatus().equals(CommandResult.ExitStatus.FAILURE)) {
            throw new Exception(result.getFailureCause());
        }

        prepareRealmUsers(realmName);
    }

    private void prepareRealmUsers(String realmName) throws IOException, Exception {
        String command;
        CommandRunner runner = (CommandRunner) gf.getCommandRunner();
        CommandResult result;

        //asadmin> create-file-user --authrealmname file --groups testuser mk --passwordfile=c:/JavaDev/Java/appservers/glassfish-3.1.1/glassfish/domains/domain1/config/passwords.txt
        ArrayList<String> users = new ArrayList<String>();
        users.add("aaa");
        users.add("aab");
        users.add("aac");
        File userPasswordFile;
        command = "create-file-user";
        for (String user : users) {
            userPasswordFile = new File(instanceRoot, "config/"+user);
            createUsersPasswordFile(userPasswordFile, user, user);
            result = runner.run(command, "--authrealmname", realmName, "--passwordfile="+userPasswordFile.getAbsolutePath(), "--groups", user, user);
            if (result.getExitStatus().equals(CommandResult.ExitStatus.FAILURE)) {
                Logger.getLogger("Test").log(Level.SEVERE, result.getOutput());
                throw new Exception(result.getFailureCause());
            }
        }
    }

    private void createUsersPasswordFile(File file, String user, String password) throws IOException {
        //usun zbędną konfigurację
        if (!file.exists()) {
            file.createNewFile();
            PrintWriter printWriter = new PrintWriter(file);
            //AS_ADMIN_USERPASSWORD=password - UWAGA - niezgodne z gokumentacją w której napisano że format to AS_ADMIN_USERPASSWORD=user-password (działa z asadmin)
            printWriter.print("AS_ADMIN_USERPASSWORD=");
            printWriter.println(password);
            printWriter.flush();
            printWriter.close();
        }
    }
}
